SystemOrganization addCategory: #'Rizel-Spy-Profiler-Tests'!

AbstractSpyTest subclass: #RzProfilerSpyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Spy-Profiler-Tests'!

!RzProfilerSpyTest commentStamp: '<historical>' prior: 0!
A RzProfilerSpyTest is a test class for testing the behavior of RzProfilerSpy!

!RzProfilerSpyTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 22:53'!
buildPendrive
	|pendrive mp3s mp4s texts images|
	pendrive := RSPenDrive new.
	mp3s := RSDirectory new.
	mp3s add: (RSMP3File named:'MP3A' size:10).
	mp3s add: (RSMP3File named:'MP3B' size:10).
	mp3s add: (RSMP3File named:'MP3C' size:10).
	mp3s add: (RSMP3File named:'MP3D' size:10).
	mp3s add: (RSMP3File named:'MP3E' size:10).
	mp3s add: (RSMP3File named:'MP3F' size:10).
	
	mp4s := RSDirectory new.	
	mp4s add: (RSMP3File named:'MP4A' size:10).
	mp4s add: (RSMP3File named:'MP4B' size:10).
	mp4s add: (RSMP3File named:'MP4C' size:10).
	mp4s add: (RSMP3File named:'MP4D' size:10).
	mp4s add: (RSMP3File named:'MP4E' size:10).
	mp4s add: (RSMP3File named:'MP4F' size:10).
	
	texts := RSDirectory new.
	texts add: (RSTextFile named:'TextA' size:10).
	texts add: (RSTextFile named:'TextB' size:10).
	texts add: (RSTextFile named:'TextC' size:10).
	texts add: (RSTextFile named:'TextD' size:10).
	texts add: (RSTextFile named:'TextE' size:10).
	texts add: (RSTextFile named:'TextF' size:10).
	
	images := RSDirectory new.
	images add: (RSImageFile named:'ImageA').
	images add: (RSImageFile named:'ImageB').
	images add: (RSImageFile named:'ImageC').
	images add: (RSImageFile named:'ImageD').
	images add: (RSImageFile named:'ImageE').
	images add: (RSImageFile named:'ImageF').
	
	pendrive add: mp3s.
	pendrive add: mp4s.	
	pendrive add: texts.
	pendrive add: images.
	
	^ pendrive.! !

!RzProfilerSpyTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 16:15'!
testBasic
	"
	self new testBasic
	"
	|profile|
	
	profile := RzProfilerSpy profile: [
		RSImageFile named: 'TestImage.jpg'.
		] inClassCategory:'Rizel-Test-Scenario'.

	self assert: (profile packages size = 1).	
	self assert: (profile allMethods notEmpty).	
	profile inspect! !

!RzProfilerSpyTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/9/2012 01:08'!
testCoverage
	"
	self new testBasic
	"
	|profile image time|
	
	image := RSImageFile named: 'TestImage.jpg' size: 10.
	profile := RzProfilerSpy profile: [
		image open.
		] inClassCategory:'Rizel-Test-Scenario'.
	time := (profile>>#RSImageFile>>#open) executionTime.

	self assert: (profile allCoveredClasses size > 1).
	self assert: (profile allCoveredMethods size > 1).
	self assert: (profile coverage > 0).! !

!RzProfilerSpyTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 17:29'!
testExecutionTime
	"
	self new testBasic
	"
	|profile image time|
	
	image := RSImageFile named: 'TestImage.jpg' size: 10.
	profile := RzProfilerSpy profile: [
		image open.
		] inClassCategory:'Rizel-Test-Scenario'.
	time := (profile>>#RSImageFile>>#open) executionTime.
	"should be 200 milliseconds"
	"instrumentation cost 20% aprox"
	self assert: ( time > 190).	
	self assert: ( time < 250).! !

!RzProfilerSpyTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 22:51'!
testExecutionTime2
	"
	self new testBasic
	"
	|profile image mp3 time time2|
	
	image := RSImageFile named: 'TestImage.jpg' size: 10.
	mp3 := RSMP3File named: 'TestImage.jpg' size: 10.
	profile := RzProfilerSpy profile: [
		image open.
		mp3 open.
		] inClassCategory:'Rizel-Test-Scenario'.
	time := (profile>>#RSImageFile>>#open) executionTime.
	time2 := (profile>>#RSMP3File>>#open) executionTime.
	"this is not good enough"
	self assert: ( time > 190).	
	self assert: ( time < 250).
	self assert: ( time2 > 200).	
	self assert: ( time2 < 300).! !

!RzProfilerSpyTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 22:33'!
testNumberOfExecution
	"
	self new testBasic
	"
	|profile image|
	
	image := RSImageFile named: 'TestImage.jpg' size: 10.
	profile := RzProfilerSpy profile: [
		10 timesRepeat: [image size].
		] inClassCategory:'Rizel-Test-Scenario'.

	self assert: ( (profile>>#RSFile>>#size) numberOfExecutions =10).	
	! !

!RzProfilerSpyTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 22:10'!
testScenario
	self buildPendrive.! !

!RzProfilerSpyTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 22:14'!
testScenario2
	|pen|
	pen := self buildPendrive.
	
	self assert: ((pen collect:[ :file |  file class = RSTextFile]) size = 6).! !
